Index: sources/app/src/main/java/parkup/entities/RegisteredUser.java
===================================================================
--- sources/app/src/main/java/parkup/entities/RegisteredUser.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
+++ sources/app/src/main/java/parkup/entities/RegisteredUser.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -0,0 +1,213 @@
+package parkup.entities;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.List;
+import javax.persistence.*;
+
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.authority.SimpleGrantedAuthority;
+import org.springframework.security.core.userdetails.UserDetails;
+import parkup.data.Plate;
+import parkup.data.enumarations.UserRole;
+
+@Entity
+@Table(name = "registeredUser")
+public class RegisteredUser implements UserDetails {
+    @Id
+    @SequenceGenerator(
+            name="registeredUser_sequence_generator",
+            sequenceName = "registeredUser_sequence",
+            allocationSize = 1,
+            initialValue = 300
+    )
+    @GeneratedValue(    //za postgres treba sequence da se namesti i ime na generator mi ga davamo kako od gore sto e
+            strategy = GenerationType.SEQUENCE,
+            generator = "registeredUser_sequence_generator"
+    )
+    @Column(name = "regParkId")
+    private int regParkId;
+
+    @Column(name = "name")
+    private String name;
+
+    @Column(name = "surname")
+    private String surname;
+
+    @Column(name = "password")
+    private String password;
+
+    @OneToMany(cascade ={CascadeType.ALL})
+    @Column(name = "regPlates")
+    private List<Plate> plates;
+
+    @Column(name = "email")
+    private String email;
+
+    @Column(name = "mobile")
+    private String mobile;
+
+    @Enumerated
+    @Column(name = "role")
+    private UserRole role;
+
+    @OneToOne
+    private ParkingSession session;
+
+    private boolean locked;
+
+    private boolean enabled;
+
+    public RegisteredUser() {
+        this.plates = new ArrayList<Plate>();
+        this.role = UserRole.REG_USER;
+        session=null;
+    }
+
+    public RegisteredUser(int regParkId, String name, String surname, String password, List<Plate> plates, String email, String mobile) {
+        this.regParkId = regParkId;
+        this.name = name;
+        this.surname = surname;
+        this.password = password;
+        this.plates = plates;
+        this.email = email;
+        this.mobile = mobile;
+        this.role = UserRole.REG_USER;
+        session=null;
+    }
+
+    public RegisteredUser(String name, String surname, String password, List<Plate> plates, String email, String mobile) {
+        this.name = name;
+        this.surname = surname;
+        this.password = password;
+        this.plates = plates;
+        this.email = email;
+        this.mobile = mobile;
+        this.role = UserRole.REG_USER;
+        session=null;
+    }
+
+    public RegisteredUser(String name, String surname, String email, String password, String mobile) {
+        this.name = name;
+        this.surname = surname;
+        this.password = password;
+        this.email = email;
+        this.mobile = mobile;
+        this.role = UserRole.REG_USER;
+        session=null;
+    }
+
+    public ParkingSession getSession() {
+        return session;
+    }
+
+    public void setSession(ParkingSession session) {
+        this.session = session;
+    }
+
+    public boolean isLocked() {
+        return locked;
+    }
+
+    public void setLocked(boolean locked) {
+        this.locked = locked;
+    }
+
+    public void setEnabled(boolean enabled) {
+        this.enabled = enabled;
+    }
+
+
+    public int getRegParkId() {
+        return regParkId;
+    }
+
+    public void setRegParkId(int regParkId) {
+        this.regParkId = regParkId;
+    }
+
+    public String getName() {
+        return name;
+    }
+
+    public void setName(String name) {
+        this.name = name;
+    }
+
+    public String getSurname() {
+        return surname;
+    }
+
+    public void setSurname(String surname) {
+        this.surname = surname;
+    }
+
+    public List<Plate> getPlates() {
+        return plates;
+    }
+
+    public void setPlates(List<Plate> plates) {
+        this.plates = plates;
+    }
+
+    public String getEmail() {
+        return email;
+    }
+
+    public void setEmail(String email) {
+        this.email = email;
+    }
+
+    public String getMobile() {
+        return mobile;
+    }
+
+    public void setMobile(String mobile) {
+        this.mobile = mobile;
+    }
+
+    public UserRole getRole() {return role;}
+
+    public void setRole(UserRole role) {this.role = role;}
+
+    @Override
+    public Collection<? extends GrantedAuthority> getAuthorities() {
+        SimpleGrantedAuthority authority = new SimpleGrantedAuthority(role.getAuthority());
+        return Collections.singleton(authority);
+    }
+
+    public String getPassword() {
+        return password;
+    }
+
+    public void setPassword(String password) {
+        this.password = password;
+    }
+
+    @Override
+    public String getUsername() {
+        return email;
+    }
+
+    @Override
+    public boolean isAccountNonExpired() {
+        return true;
+    }
+
+    @Override
+    public boolean isAccountNonLocked() {
+        return !locked;
+    }
+
+    @Override
+    public boolean isCredentialsNonExpired() {
+        return true;
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return enabled;
+    }
+}
+
Index: sources/app/src/main/java/parkup/entities/Worker.java
===================================================================
--- sources/app/src/main/java/parkup/entities/Worker.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
+++ sources/app/src/main/java/parkup/entities/Worker.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -0,0 +1,221 @@
+package parkup.entities;
+
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.authority.SimpleGrantedAuthority;
+import org.springframework.security.core.userdetails.UserDetails;
+import parkup.data.enumarations.EmployeeStatus;
+import parkup.data.enumarations.UserRole;
+
+import javax.persistence.*;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.List;
+
+@Entity
+@Table(name = "worker")
+public class Worker implements UserDetails {
+    @Id
+    @SequenceGenerator(
+            name="worker_sequence_generator",
+            sequenceName = "worker_sequence",
+            allocationSize = 1,
+            initialValue = 200
+    )
+    @GeneratedValue(    //za postgres treba sequence da se namesti i ime na generator mi ga davamo kako od gore sto e
+            strategy = GenerationType.SEQUENCE,
+            generator = "worker_sequence_generator"
+    )
+    @Column(name = "workerId")
+    private int workerId;
+
+    @Override
+    public String toString() {
+        return "Vraboten{" +
+                "firstName='" + firstName + '\'' +
+                ", lastName='" + lastName + '\'' +
+                ", parkingZones=" + parkingZones +
+                ", locked=" + locked +
+                ", enabled=" + enabled +
+                '}';
+    }
+
+    @Column(name = "firstName")
+    private String firstName;
+
+    @Column(name = "lastName")
+    private String lastName;
+
+    @Column(name = "email")
+    private String email;
+
+    @Column(name = "password")
+    private String password;
+
+    @Column(name = "mobile")
+    private String mobile;
+
+    @Enumerated
+    @Column(name = "role")
+    private UserRole role;
+
+    @ManyToMany(cascade = {CascadeType.ALL})
+    private List<ParkingZone> parkingZones;
+
+    @Column(name = "status")
+    private EmployeeStatus status;
+
+    public void setLocked(boolean locked) {
+        this.locked = locked;
+    }
+
+    @Column(name="locked")
+    private boolean locked;
+
+    @Column(name = "enabled")
+    private boolean enabled;
+
+
+    public Worker() {
+        this.role = UserRole.WORKER;
+        this.parkingZones = new ArrayList<ParkingZone>();
+        this.enabled = true;
+        this.status = EmployeeStatus.NOT_WORKING;
+    }
+
+    public Worker(int workerId, String firstName, String lastName, String email, String password, String mobile, List<ParkingZone> parkingZones) {
+        this.workerId = workerId;
+        this.firstName = firstName;
+        this.lastName = lastName;
+        this.email = email;
+        this.password = password;
+        this.mobile = mobile;
+        this.parkingZones = parkingZones;
+        this.role = UserRole.WORKER;
+        this.enabled = true;
+        this.status = EmployeeStatus.NOT_WORKING;
+    }
+
+    public Worker(String firstName, String lastName, String email, String password, String mobile, List<ParkingZone> parkingZones) {
+        this.firstName = firstName;
+        this.lastName = lastName;
+        this.email = email;
+        this.password = password;
+        this.mobile = mobile;
+        this.parkingZones = parkingZones;
+        this.role = UserRole.WORKER;
+        this.enabled = true;
+        this.status = EmployeeStatus.NOT_WORKING;
+    }
+
+    public Worker(String firstName, String lastName, String email, String password, String mobile) {
+        this.firstName=firstName;
+        this.lastName=lastName;
+        this.email=email;
+        this.password=password;
+        this.mobile=mobile;
+        this.parkingZones=new ArrayList<>();
+        this.role = UserRole.WORKER;
+        this.enabled=true;
+        this.status = EmployeeStatus.NOT_WORKING;
+    }
+
+    public int getWorkerId() {
+        return workerId;
+    }
+
+    public void setWorkerId(int workerId) {
+        this.workerId = workerId;
+    }
+
+    public String getFirstName() {
+        return firstName;
+    }
+
+    public void setFirstName(String firstName) {
+        this.firstName = firstName;
+    }
+
+    public String getLastName() {
+        return lastName;
+    }
+
+    public void setLastName(String lastName) {
+        this.lastName = lastName;
+    }
+
+    public String getEmail() {
+        return email;
+    }
+
+    public void setEmail(String email) {
+        this.email = email;
+    }
+
+    @Override
+    public Collection<? extends GrantedAuthority> getAuthorities() {
+        SimpleGrantedAuthority authority = new SimpleGrantedAuthority(role.getAuthority());
+        return Collections.singleton(authority);
+    }
+
+    public String getPassword() {
+        return password;
+    }
+
+    @Override
+    public String getUsername() {
+        return email;
+    }
+
+    @Override
+    public boolean isAccountNonExpired() {
+        return true;
+    }
+
+    @Override
+    public boolean isAccountNonLocked() {
+        return !locked;
+    }
+
+    public void lockVraboten(){
+        this.locked = !locked;
+    }
+
+    @Override
+    public boolean isCredentialsNonExpired() {
+        return true;
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return enabled;
+    }
+
+    public void setPassword(String password) {
+        this.password = password;
+    }
+
+    public String getMobile() {
+        return mobile;
+    }
+
+    public void setMobile(String mobile) {
+        this.mobile = mobile;
+    }
+
+    public UserRole getRole() {return role;}
+
+    public void setRole(UserRole role) {this.role = role;}
+
+    public List<ParkingZone> getParkingZones() {return parkingZones;}
+
+    public void setParkingZones(List<ParkingZone> parkingZones) {this.parkingZones = parkingZones;}
+
+    public EmployeeStatus getStatus() {return status;}
+
+    public void setStatus(EmployeeStatus status) {this.status = status;}
+
+    public boolean isAccount() {return enabled;}
+
+    public void setAccount(boolean account) {this.enabled = account;}
+}
Index: sources/app/src/main/java/parkup/repositories/PlateRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/PlateRepository.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
+++ sources/app/src/main/java/parkup/repositories/PlateRepository.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -0,0 +1,8 @@
+package parkup.repositories;
+
+import org.springframework.data.jpa.repository.JpaRepository;
+import parkup.data.Plate;
+
+public interface PlateRepository extends JpaRepository<Plate,Integer> {
+    Plate findByPlate(String plate);
+}
Index: sources/app/src/main/java/parkup/repositories/RegisteredUserRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/RegisteredUserRepository.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
+++ sources/app/src/main/java/parkup/repositories/RegisteredUserRepository.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -0,0 +1,25 @@
+package parkup.repositories;
+
+import java.util.Optional;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Modifying;
+import org.springframework.data.jpa.repository.Query;
+import org.springframework.stereotype.Repository;
+import parkup.entities.RegisteredUser;
+
+import javax.transaction.Transactional;
+
+@Repository
+public interface RegisteredUserRepository extends JpaRepository<RegisteredUser, Integer> {
+    RegisteredUser findByRegParkId(int regParkId);
+
+    void deleteByRegParkId(int regParkId);
+
+    Optional<RegisteredUser> findRegisteredUserByEmail(String email);
+
+    @Transactional
+    @Modifying
+    @Query("UPDATE RegisteredUser rp " +
+            "SET rp.enabled = TRUE WHERE rp.email = ?1")
+    int enableRegisteredUser(String email);
+}
Index: sources/app/src/main/java/parkup/repositories/WorkerRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/WorkerRepository.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
+++ sources/app/src/main/java/parkup/repositories/WorkerRepository.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -0,0 +1,25 @@
+package parkup.repositories;
+
+import java.util.Optional;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Modifying;
+import org.springframework.data.jpa.repository.Query;
+import org.springframework.stereotype.Repository;
+import parkup.entities.Worker;
+
+import javax.transaction.Transactional;
+
+@Repository
+public interface WorkerRepository extends JpaRepository<Worker, Integer> {
+    Worker findByWorkerId(int id);
+
+    void deleteByWorkerId(int id);
+
+    Optional<Worker> findWorkerByEmail(String email);
+
+    @Transactional
+    @Modifying
+    @Query("UPDATE Worker a " +
+            "SET a.enabled = TRUE WHERE a.email = ?1")
+    int enableWorker(String email);
+}
Index: sources/app/src/main/java/parkup/services/AdministratorService.java
===================================================================
--- sources/app/src/main/java/parkup/services/AdministratorService.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
+++ sources/app/src/main/java/parkup/services/AdministratorService.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -21,12 +21,10 @@
     private final AdministratorRepository administratorRepository;
     private final BCryptPasswordEncoder bCryptPasswordEncoder;
-    private final ConfirmationTokenService confirmationTokenService;
-    private EmailValidator emailValidator;
+
 
     @Autowired
-    public AdministratorService(AdministratorRepository administratorRepository, BCryptPasswordEncoder bCryptPasswordEncoder, ConfirmationTokenService confirmationTokenService) {
+    public AdministratorService(AdministratorRepository administratorRepository, BCryptPasswordEncoder bCryptPasswordEncoder) {
         this.administratorRepository = administratorRepository;
         this.bCryptPasswordEncoder = bCryptPasswordEncoder;
-        this.confirmationTokenService = confirmationTokenService;
     }
 
@@ -46,5 +44,5 @@
         } else {
             if (administrator.getEmail() != null && administrator.getEmail().length() > 1 && administrator.getEmail().contains("@")) {
-                //System.out.println(regPark);
+                administrator.setPassword(bCryptPasswordEncoder.encode(administrator.getPassword()));
                 this.administratorRepository.save(administrator);
             }
@@ -108,40 +106,4 @@
     }
 
-   //public String register(RegistrationRequest request) {
-   //    boolean isValidEmail = emailValidator.test(request.getEmail());
-   //    if (!isValidEmail){
-   //        throw new IllegalStateException("Email not valid");
-   //    }
-   //    return "it works";
-   //}
-
-    public String signUpAdministrator(Administrator administrator){
-        boolean administratorExists = administratorRepository
-                .findAdministratorByEmail(administrator.getEmail())
-                .isPresent();
-        if(administratorExists){
-            // TODO check if attributes are the same and
-            // TODO if email not confirmed send confirmation email
-
-            throw new IllegalStateException("Email already taken");
-        }
-
-        String encodedPassword = bCryptPasswordEncoder
-                .encode(administrator.getPassword());
-
-        administrator.setPassword(encodedPassword);
-
-        administratorRepository.save(administrator);
-
-        // TODO: Send confirmation token
-
-        String token = UUID.randomUUID().toString();
-
-
-        // TODO: SEND EMAIL
-
-        return token;
-    }
-
     public int enableAdministrator(String email) {
         return administratorRepository.enableAdministrator(email);
Index: sources/app/src/main/java/parkup/services/ParkingSessionService.java
===================================================================
--- sources/app/src/main/java/parkup/services/ParkingSessionService.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
+++ sources/app/src/main/java/parkup/services/ParkingSessionService.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -3,5 +3,5 @@
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.stereotype.Service;
-import parkup.data.Tablicka;
+import parkup.data.Plate;
 import parkup.data.enumarations.SessionStatus;
 import parkup.entities.ParkingSession;
@@ -11,5 +11,5 @@
 import parkup.repositories.ParkingSpaceRepository;
 import parkup.repositories.ParkingZoneRepository;
-import parkup.repositories.TablickaRepository;
+import parkup.repositories.PlateRepository;
 
 import javax.transaction.Transactional;
@@ -25,12 +25,12 @@
     private final ParkingZoneRepository parkingZoneRepository;
     private final ParkingSpaceRepository parkingSpaceRepository;
-    private final TablickaRepository tablickaRepository;
+    private final PlateRepository plateRepository;
 
     @Autowired
-    public ParkingSessionService(ParkingSessionRepository parkingSessionRepository, ParkingZoneRepository parkingZoneRepository, ParkingSpaceRepository parkingSpaceRepository, TablickaRepository tablickaRepository) {
+    public ParkingSessionService(ParkingSessionRepository parkingSessionRepository, ParkingZoneRepository parkingZoneRepository, ParkingSpaceRepository parkingSpaceRepository, PlateRepository plateRepository) {
         this.parkingSessionRepository = parkingSessionRepository;
         this.parkingZoneRepository = parkingZoneRepository;
         this.parkingSpaceRepository = parkingSpaceRepository;
-        this.tablickaRepository = tablickaRepository;
+        this.plateRepository = plateRepository;
     }
 
@@ -83,10 +83,10 @@
     public Optional<ParkingSession> startParkingSession(String tablica, int parkingZoneId) {
         ParkingZone parkingZone = parkingZoneRepository.findByPzId(parkingZoneId);
-        Tablicka tablicka = tablickaRepository.findByTablica(tablica);
-        if(tablicka==null) {
-            tablickaRepository.save(new Tablicka(tablica));
+        Plate plate = plateRepository.findByPlate(tablica);
+        if(plate ==null) {
+            plateRepository.save(new Plate(tablica));
         }
-        tablicka=tablickaRepository.findByTablica(tablica);
-        ParkingSession sessionToAdd = new ParkingSession(tablicka);
+        plate = plateRepository.findByPlate(tablica);
+        ParkingSession sessionToAdd = new ParkingSession(plate);
         sessionToAdd.setParkingZone(parkingZone);
         parkingSessionRepository.save(sessionToAdd);
Index: sources/app/src/main/java/parkup/services/ParkingSpaceService.java
===================================================================
--- sources/app/src/main/java/parkup/services/ParkingSpaceService.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
+++ sources/app/src/main/java/parkup/services/ParkingSpaceService.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -4,4 +4,5 @@
 import org.springframework.stereotype.Service;
 import parkup.entities.ParkingSpace;
+import parkup.entities.ParkingZone;
 import parkup.repositories.ParkingSpaceRepository;
 import parkup.repositories.ParkingZoneRepository;
@@ -48,6 +49,6 @@
         Optional<ParkingSpace> ParkingSpaceOpt = Optional.ofNullable(parkingSpaceRepository.findByPsId(parkingSpaceId));
         if (ParkingSpaceOpt.isPresent()) {
-            ParkingSpace ParkingSpaceNov = parkingSpaceRepository.findByPsId(parkingSpaceId);
-            if (psName != null && psName.length() > 1 && !Objects.equals(ParkingSpaceNov.getPsName(), psName)) {
+            ParkingSpace parkingSpaceNew = parkingSpaceRepository.findByPsId(parkingSpaceId);
+            if (psName != null && psName.length() > 1 && !Objects.equals(parkingSpaceNew.getPsName(), psName)) {
                 Optional<ParkingSpace> parkingSpaceOpt1 = Optional.ofNullable(parkingSpaceRepository.findByPsName(psName));
                 if (parkingSpaceOpt1.isPresent()) {
@@ -55,20 +56,20 @@
                 }
 
-                ParkingSpaceNov.setPsName(psName);
+                parkingSpaceNew.setPsName(psName);
             }
 
-            if (!Objects.equals(ParkingSpaceNov.isTaken(), taken)) {
-                ParkingSpaceNov.setTaken(taken);
+            if (!Objects.equals(parkingSpaceNew.isTaken(), taken)) {
+                parkingSpaceNew.setTaken(taken);
             }
 
 
-            if(lat!=0 && !Objects.equals(ParkingSpaceNov.getLat(), lat)){
-                ParkingSpaceNov.setLat(lat);
+            if(lat!=0 && !Objects.equals(parkingSpaceNew.getLat(), lat)){
+                parkingSpaceNew.setLat(lat);
             }
 
-            if(lng!=0 && !Objects.equals(ParkingSpaceNov.getLng(), lng)){
-                ParkingSpaceNov.setLng(lng);
+            if(lng!=0 && !Objects.equals(parkingSpaceNew.getLng(), lng)){
+                parkingSpaceNew.setLng(lng);
             }
-            return ParkingSpaceNov;
+            return parkingSpaceNew;
         }else{
             throw new IllegalStateException("ParkingSpace does not exist");
@@ -80,4 +81,8 @@
         Optional<ParkingSpace> parkingSpaceOpt = Optional.ofNullable(parkingSpaceRepository.findByPsId(parkingSpaceId));
         if (parkingSpaceOpt.isPresent()) {
+            for(ParkingZone pz: parkingZoneRepository.findAll()){
+                pz.getParkingSpaces().remove(parkingSpaceOpt.get());
+                parkingZoneRepository.save(pz);
+            }
             parkingSpaceRepository.deleteByPsId(parkingSpaceId);
         } else {
Index: sources/app/src/main/java/parkup/services/ParkingZoneService.java
===================================================================
--- sources/app/src/main/java/parkup/services/ParkingZoneService.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
+++ sources/app/src/main/java/parkup/services/ParkingZoneService.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -4,12 +4,11 @@
 import org.springframework.stereotype.Service;
 import parkup.data.ParkingZoneLocation;
-import parkup.entities.ParkingSession;
 import parkup.entities.ParkingSpace;
 import parkup.entities.ParkingZone;
-import parkup.entities.Vraboten;
+import parkup.entities.Worker;
 import parkup.repositories.ParkingSessionRepository;
 import parkup.repositories.ParkingSpaceRepository;
 import parkup.repositories.ParkingZoneRepository;
-import parkup.repositories.VrabotenRepository;
+import parkup.repositories.WorkerRepository;
 
 import javax.transaction.Transactional;
@@ -23,22 +22,30 @@
     private final ParkingZoneRepository parkingZoneRepository;
     private final ParkingSpaceRepository parkingSpaceRepository;
-    private final VrabotenRepository vrabotenRepository;
+    private final WorkerRepository workerRepository;
     private final ParkingSessionRepository parkingSessionRepository;
 
     @Autowired
-    public ParkingZoneService(ParkingZoneRepository parkingZoneRepository, ParkingSpaceRepository parkingSpaceRepository, VrabotenRepository vrabotenRepository, ParkingSessionRepository parkingSessionRepository) {
+    public ParkingZoneService(ParkingZoneRepository parkingZoneRepository, ParkingSpaceRepository parkingSpaceRepository, WorkerRepository workerRepository, ParkingSessionRepository parkingSessionRepository) {
         this.parkingZoneRepository = parkingZoneRepository;
         this.parkingSpaceRepository = parkingSpaceRepository;
         this.parkingSessionRepository = parkingSessionRepository;
-        this.vrabotenRepository = vrabotenRepository;
+        this.workerRepository = workerRepository;
     }
 
     public List<ParkingZone> getAllParkingZones() {
-        return parkingZoneRepository.findAll();
+        List<ParkingZone> parkingZones= parkingZoneRepository.findAll();
+        for(ParkingZone pz:parkingZones){
+            setTransientVariables(pz.getId());
+        }
+        return parkingZones;
     }
 
     public ParkingZone findById(int parkingZoneId) {
         Optional<ParkingZone> parkingZone = Optional.ofNullable(this.parkingZoneRepository.findByPzId(parkingZoneId));
-        return parkingZone.orElse(null);
+        if (!parkingZone.isPresent()) {
+            throw new IllegalStateException("ParkingZone does not exist");
+        }
+        setTransientVariables(parkingZone.get().getId());
+        return parkingZone.get();
     }
 
@@ -134,7 +141,7 @@
                     ParkingZone parkingZone = parkingZoneRepository.findByPzId(parkingZoneId);
                     for (Integer vrabotenId : odgovorniLica) {
-                        Vraboten vrabotenToAdd = vrabotenRepository.findByVrabotenId(vrabotenId);
-                        if(vrabotenToAdd!=null)
-                        vrabotenToAdd.getParkingZones().add(parkingZone);
+                        Worker workerToAdd = workerRepository.findByWorkerId(vrabotenId);
+                        if(workerToAdd !=null)
+                        workerToAdd.getParkingZones().add(parkingZone);
                     }
                 }
@@ -158,4 +165,17 @@
             return parkingZoneOpt;
         }
+
+        public int calculateTakenSpaces(int pzId){
+            ParkingZone parkingZone=parkingZoneRepository.findByPzId(pzId);
+            return (int)parkingZone.getParkingSpaces().stream().filter(ParkingSpace::isTaken).count();
+        }
+        public int calculateCapacity(int pzId){
+            ParkingZone parkingZone=parkingZoneRepository.findByPzId(pzId);
+            return parkingZone.getParkingSpaces().size();
+        }
+        public void setTransientVariables(int pzId){
+            calculateCapacity(pzId);
+            calculateTakenSpaces(pzId);
+        }
     }
 
